#!/usr/bin/python
# *-* coding: utf8 -*-
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


import gtk, mgtk
import FileWorker

class Document(mgtk.ScrolledTextView, FileWorker.FileWorker):
	PIE = ''

	def __init__(self,PIE,strFileName=None):
		mgtk.ScrolledTextView.__init__(self)
		self.PIE = PIE
		if strFileName==None:
			self.label = gtk.Label('untitled')
		else:
			if(self.PIE.env.get_display_document_label_with_full_path()):
				self.label = gtk.Label(strFileName)
			else:
				self.label = gtk.Label(strFileName.split("/")[-1])
			self.set_text(self.open(strFileName))
			self.syntaxHighlight()
	
	def getLabel(self):
		return self.label

	def docSaveUpdate(self):
		FileWorker.FileWorker.overwrite(self,self.get_text_all())

	def docSaveNew(self,strFileName):
		FileWorker.FileWorker.write(self,strFileName,self.get_text_all())

	def syntaxHighlight(self):
		sfile = open('syntax/python.stx','r')
		while 1:
			line = sfile.readline()
			if not line: break
			if (line[0] != '#') and (line[0] != '\n') and (line[0] != '\r'):
				if (line[-2:] == '\r\n'): line = line[:-2]
				self.syntaxAdd(line, '#008000')
		sfile.close()
		self.setSyntaxHighlight(True)
