# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

from Document import *
import gtk

class DocumentManager(gtk.Notebook):
	documentList = []
	PIE = ''
	
	def __init__(self, PIE):
		gtk.Notebook.__init__(self)
		self.PIE = PIE
		self.set_tab_pos(gtk.POS_BOTTOM)
		self.set_scrollable(gtk.TRUE)
		self.show()
		self.newDoc()
	
	#create the new document object. using in newDoc() and openDoc()
	def createNewDocument(self,tmpName=None):
		if tmpName==None:
			self.documentList.append(Document(self.PIE))
			self.document = self.getLastDoc()
		else:
			self.documentList.append(Document(self.PIE,tmpName))
			self.document = self.getLastDoc()
		self.document.set_modified(False)
		return self.document

	#syncronize between self.document and current document that was opened.
	def syncDoc(self):
		self.document = self.documentList[self.get_current_page()]

	def newDoc(self):
		self.append_page(self.createNewDocument(),self.document.getLabel())
		self.set_current_page(self.getLastDocNum())
	
	def openDoc(self,strFile):
		self.append_page(self.createNewDocument(strFile),self.document.getLabel())
		self.set_current_page(self.getLastDocNum())
	
	def closeDoc(self):
		num = self.get_current_page()
		self.remove_page(num)
		del(self.documentList[num])
		num = self.getLastDoc()
	
	def docSaveUpdate(self):
		self.syncDoc()
		self.document.docSaveUpdate()

	def docSaveNew(self, strFile):
		self.syncDoc()
		self.document.docSaveNew(strFile)
	
	def getDocument(self, pageNum=None):
		if(pageNum):
			#FIXME-FIXME-FIXME
			print "FIXME"
		else:
			return self.documentList[self.get_current_page()]

	def getLastDocNum(self):
		return (len(self.documentList) - 1)
	
	def getLastDoc(self):
		return self.documentList[self.getLastDocNum()]
