# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import gtk
import mgtk

class LineMover(gtk.Dialog):
	def __init__(self, document):
		gtk.Dialog.__init__(self, 'Line Mover')
		self.doc = document

		self.entry = mgtk.Entry(10)
		self.vbox.pack_start(self.entry, gtk.FILL, gtk.FILL, 0)

		self.btnMov = mgtk.Button("Move")
		self.action_area.pack_start(self.btnMov, gtk.FILL, gtk.FILL, 0)

		self.btnCan = mgtk.Button("Cancel")
		self.action_area.pack_start(self.btnCan, gtk.EXPAND, gtk.FILL, 0)

		self.eventConnection()
		self.show()

	def eventConnection(self):
		self.connect("key-press-event", self.keyEventConnection)
		self.btnMov.connect("clicked", self.move)
		self.btnCan.connect("clicked", lambda w: self.destroy())

	def keyEventConnection(self, widget, event):
		#ESC(65307)
		if (event.state == 0 and event.keyval == 65307): self.destroy()
		#Enter(65293)

	def move(self, widget):
		self.doc.move_cursor_onscreen_by_line(int(self.entry.get_text()))
