# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import gtk
import mgtk

class Window(gtk.Window):
	def __init__(self,strFileName=None):
		gtk.Window.__init__(self,gtk.WINDOW_TOPLEVEL)

		self.set_border_width(0)
		self.set_default_size(620,450)
		self.table = mgtk.Table(0, 2, gtk.FALSE)

		self.box1 = gtk.HBox(gtk.FALSE, 0)

		self.menuCreation()
		self.table.attach(self.menubar, 0, 2, 0, 1, gtk.FILL, gtk.FILL)

		self.toolbarCreation()
		self.table.attach(self.tb, 0, 2, 1, 2, gtk.FILL, gtk.FILL)

		self.sb = mgtk.Statusbar()
		self.sb_id = self.sb.get_context_id('status bar')
		self.sb.push(self.sb_id,'a simple editor')
		self.table.attach(self.sb, 0, 2, 4, 5, gtk.FILL, gtk.FILL)

		self.add(self.table)
		self.show() 

	def push_message(self,txt):
		self.sb.pop(self.sb_id)
		self.sb.push(self.sb_id,txt)

	def set_document(self,tmpWidget):
		self.table.attach(tmpWidget, 0, 2, 2, 3)

	def menuCreation(self):
		self.menubar = mgtk.MenuBar()
		self.menus = {
			'file' : mgtk.MenuItem("File"),
			'edit' : mgtk.MenuItem("Edit"),
			'view' : mgtk.MenuItem("View")}

		self.menu_items = {
			'new' : mgtk.MenuItem("New"),
			'open' : mgtk.MenuItem("Open"),
			'close' : mgtk.MenuItem("Close"),
			'save' : mgtk.MenuItem("Save"),
			'save_as' : mgtk.MenuItem("Save As"),
			'quit' : mgtk.MenuItem("Quit"),
			'line_move' : mgtk.MenuItem("Line Move"),
			'search' : mgtk.MenuItem("Search"),
			'replace' : mgtk.MenuItem("replace")}

		self.mbMenu1_menu = gtk.Menu()
		self.menus['file'].set_submenu(self.mbMenu1_menu)
		self.mbMenu1_menu.append(self.menu_items['new'])
		self.mbMenu1_menu.append(self.menu_items['open'])
		self.mbMenu1_menu.append(self.menu_items['close'])
		self.mbMenu1_menu.append(self.menu_items['save'])
		self.mbMenu1_menu.append(self.menu_items['save_as'])
		self.mbMenu1_menu.append(self.menu_items['quit'])
		self.menubar.append(self.menus['file'])

		self.mbMenu2_menu = gtk.Menu()
		self.menus['edit'].set_submenu(self.mbMenu2_menu)
		self.mbMenu2_menu.append(self.menu_items['line_move'])
		self.mbMenu2_menu.append(self.menu_items['search'])
		self.mbMenu2_menu.append(self.menu_items['replace'])
		self.menubar.append(self.menus['edit'])

	def toolbarCreation(self):
		self.tb = mgtk.Toolbar()

		icon_new = mgtk.Image()
		icon_new.set_from_stock(gtk.STOCK_NEW,3)
		icon_open = mgtk.Image()
		icon_open.set_from_stock(gtk.STOCK_OPEN,3)
		icon_save = mgtk.Image()
		icon_save.set_from_stock(gtk.STOCK_SAVE,3)
		icon_save_as = mgtk.Image()
		icon_save_as.set_from_stock(gtk.STOCK_SAVE_AS,3)
		icon_close = mgtk.Image()
		icon_close.set_from_stock(gtk.STOCK_CLOSE,3)
		icon_quit = mgtk.Image()
		icon_quit.set_from_stock(gtk.STOCK_QUIT,3)

		self.toolbar_buttons = {
			'new' : mgtk.ToolButton(icon_new,'New'),
			'open' : mgtk.ToolButton(icon_open,'Open'),
			'close' : mgtk.ToolButton(icon_close,'Close'),
			'save' : mgtk.ToolButton(icon_save,'Save'),
			'save_as' : mgtk.ToolButton(icon_save_as,'Save As'),
			'quit' : mgtk.ToolButton(icon_quit,'Quit')}

		self.tb.insert(self.toolbar_buttons['new'],-1)
		self.tb.insert(self.toolbar_buttons['open'],-1)
		self.tb.insert(self.toolbar_buttons['save'],-1)
		self.tb.insert(self.toolbar_buttons['save_as'],-1)
		self.tb.insert(self.toolbar_buttons['close'],-1)
		self.tb.insert(self.toolbar_buttons['quit'],-1)
