#!/usr/bin/python
# *-* coding: utf8 -*-
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

# m : pygtk extention pack
import gtk

def Button(txt):
	btn = gtk.Button(txt)
	btn.show()
	return btn

def Entry(int):
	ent = gtk.Entry(int)
	ent.show()
	return ent

def Image():
	img = gtk.Image()
	img.show()
	return img

def MenuBar():
	mb = gtk.MenuBar()
	mb.show()
	return mb

def MenuItem(txt):
	mi = gtk.MenuItem(txt)
	mi.show()
	return mi

def Notebook():
	nb = gtk.Notebook()
	nb.show()
	return nb



class TextBuffer(gtk.TextBuffer):
	def __init__(self):
		gtk.TextBuffer.__init__(self)

	def get_text(self, start_offset, end_offset, bool):
		return gtk.TextBuffer.get_text(self, self.get_iter_at_offset(start_offset), self.get_iter_at_offset(end_offset), bool)

	def apply_tag(self, tag, start_offset, end_offset):
		gtk.TextBuffer.apply_tag(self, tag, self.get_iter_at_offset(start_offset), self.get_iter_at_offset(end_offset))

	def remove_all_tags(self, start_offset, end_offset):
		gtk.TextBuffer.remove_all_tags(self, self.get_iter_at_offset(start_offset), self.get_iter_at_offset(end_offset))

def ToolButton(icon_widget=None, label=None):
	ti = gtk.ToolButton(icon_widget, label)
	ti.show()
	return ti

class ScrolledTextView(gtk.ScrolledWindow):
	keywordList = {}
	syntaxHighlight = False

	def __init__(self):
		gtk.ScrolledWindow.__init__(self)
		self.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		self.textView = TextView()
		#self.textBuffer = self.textView.get_buffer()
		self.textBuffer = TextBuffer()
		self.textView.set_buffer(self.textBuffer)
		
		self.textTagTable = self.textBuffer.get_tag_table()
		
		self.add(self.textView)
		self.show()

	def syntaxAdd(self, txt, color):
		self.keywordList[txt] = color

	def syntaxDel(self, txt):
		del(self.keywordList[txt])

	def setSyntaxHighlight(self, bool):
		self.syntaxHighlight = bool
		if (bool == True):
			self.repaintSyntaxHighlight()

	def repaintSyntaxHighlight(self):
		self.textBuffer.remove_all_tags(0, -1)
		txt = self.get_text_all()
		tag = gtk.TextTag()
		self.textTagTable.add(tag)
		for keyword in self.keywordList:
			end_offset = 0
			while 1:
				start_offset = txt.find(keyword, end_offset)
				if (start_offset == -1):
					break
				else:
					end_offset = start_offset + len(keyword)
					if(((txt[start_offset-1]==' ') or
					(txt[start_offset-1]=='.') or
					(txt[start_offset-1]==':') or
					(txt[start_offset-1]=='\t') or
					(txt[start_offset-1]=='\n') or
					(txt[start_offset-1]=='\r') or
					(txt[start_offset-1]=='(') or
					(txt[start_offset-1]==')')) and
					((txt[end_offset]==' ') or
					(txt[end_offset]=='.') or
					(txt[end_offset]=='(') or
					(txt[end_offset]==')') or
					(txt[end_offset]=='\n') or
					(txt[end_offset]=='\r') or
					(txt[end_offset]=='\t') or
					(txt[end_offset]==':'))):
						tag.set_property('foreground-gdk',gtk.gdk.color_parse(self.keywordList[keyword]))
						self.textBuffer.apply_tag(tag, start_offset, end_offset)

	def repaintCurrentLine(self):
		#self.textBuffer.remove_all_tags(0, -1)
		txt = self.get_text_at_current_line()

		tag = gtk.TextTag()
		self.textTagTable.add(tag)
		for keyword in self.keywordList:
			end_offset = 0
			while 1:
				start_offset = txt.find(keyword, end_offset)
				if (start_offset == -1):
					break
				else:
					tag.set_property('foreground',self.keywordList[keyword])
					end_offset = start_offset + len(keyword)
					self.textBuffer.apply_tag(tag, start_offset, end_offset)

	def get_buffer(self):
		return self.textBuffer

	def set_modified(self, setting):
		self.textBuffer.set_modified(setting)

	def get_modified(self):
		return self.textBuffer.get_modified()

	def set_text(self,txt):
		self.textBuffer.set_text(txt)

	def clear(self):
		self.textBuffer.set_text('')

	def get_current_line_number(self):
		textMark = self.textBuffer.get_insert()
		textIter = self.textBuffer.get_iter_at_mark(textMark)
		return str(textIter.get_line() + 1)
		
	def get_total_line_count(self):
		return str(self.textBuffer.get_line_count())

	def get_current_char_number(self):
		textMark = self.textBuffer.get_insert()
		textIter = self.textBuffer.get_iter_at_mark(textMark)
		return str(textIter.get_line_offset() + 1)

	def get_total_char_count_at_current_line(self):
		textMark = self.textBuffer.get_insert()
		textIter = self.textBuffer.get_iter_at_mark(textMark)
		return str(textIter.get_chars_in_line())

	def get_total_char_count(self):
		return str(self.textBuffer.get_char_count() + 1)

	def get_text_at_current_line(self):
		textIter = self.textBuffer.get_insert()
		textIter = self.textBuffer.get_iter_at_mark(textIter)
		textIter = self.textBuffer.get_iter_at_line(textIter.get_line())
		start_offset = textIter.get_offset()
		
		textIter = self.textBuffer.get_iter_at_line(textIter.get_line() + 1)
		end_offset = textIter.get_offset() - 1
		if end_offset == (start_offset - 1) : end_offset = -1
		return self.textBuffer.get_text(start_offset, end_offset, gtk.TRUE)
		
		#print textIter.get_chars_in_line()
		#char number at this line

	def get_text_all(self):
		return self.textBuffer.get_text(0, -1, gtk.TRUE)

	def set_foreground_color(self, color):
		#sob, eob = self.textBuffer.get_bounds()
		tag = gtk.TextTag()
		tag.set_property('foreground',color)
		self.textTagTable.add(tag)
		#self.textBuffer.apply_tag(tag, sob, eob)
		self.textBuffer.apply_tag(tag, 0, -1)

	def set_foreground_color_by_offset(self, color, start_offset, end_offset):
		tag = gtk.TextTag()
		tag.set_property('foreground',color)
		self.textTagTable.add(tag)
		self.textBuffer.apply_tag(tag, start_offset, end_offset)

	def set_foreground_color_by_text(self, color, text):
		txt = self.get_text_all()
		tag = gtk.TextTag()
		tag.set_property('foreground',color)
		self.textTagTable.add(tag)
		end_offset = 0
		while 1:
			start_offset = txt.find(text, end_offset)
			if (start_offset == -1): break
			end_offset = start_offset + len(text)
			self.textBuffer.apply_tag(tag, start_offset, end_offset)

	def move_cursor_onscreen_by_line(self, line):
		iter = self.textBuffer.get_iter_at_line(line)
		self.textBuffer.place_cursor(iter)
		self.textView.scroll_to_iter(iter, 0.0)
		

def ScrolledWindow():
	sw = gtk.ScrolledWindow()
	sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
	sw.show()
	return sw

def Statusbar():
	sb = gtk.Statusbar()
	sb.show()
	return sb

def Table(vertical, horizontal, bool):
	tb = gtk.Table(vertical, horizontal, bool)
	tb.show()
	return tb

def TextView():
	tv = gtk.TextView()
	tv.show()
	return tv

def Toolbar():
	tb = gtk.Toolbar()
	tb.show()
	return tb
